/* Read Utility
 *
 * Version 1.0
 * 12/19/2020
 *
 * r.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#define PROG_HELP \
"Read Utility: Display contents of files\n\
\n\
r [-H] [-f] <file ...>\n\
\n\
\t[-H] - Display program syntax and options\n\
\t[-f] - Display file name before contents of file\n"

#define NAME_FORMAT	"\n/* File: %s */\n\n"

#define _USAGE "Usage: %s [-H] [-f] <file ...>\n"

#define OPT_HELP	'H'
#define OPT_NAMES	'f'

char options[] = "";

enum
{
	_NONE,
	_FILE,
	_DIR
};

int inopts(char opt)
{
	static int sr;
	sr = 0;
	int z;

	for (z = 0; z <= strlen(options); z++)
	{
		if (options[z] == opt)
		{
			sr = 1;
			break;
		} else {
			continue;
		}
	}

	return sr;
}

int ftype(char file[])
{
	struct stat fstat;
	int s = stat(file, &fstat);
	if (s != 0)
	{
		return _NONE;
	}
	if (S_ISREG (fstat.st_mode)) 
	{
		return _FILE;
	} else if (S_ISDIR (fstat.st_mode)) 
	{
		return _DIR;
	} else {
		return _NONE;
	}
}

int main(int argc, char *argv[])
{
	FILE *fptr;
	char c;	
	int a, b, shownames;
	int p = 1;
	int r;

	if (argc >= 2 && argv[1][0] == '-')
	{
		p = 2;

		for (r = 1; r < strlen(argv[1]); r++)
		{
			options[r - 1] = argv[1][r];
		}
	}

	if (inopts(OPT_HELP))
	{
		printf(PROG_HELP);
		exit(0);
	}

	if (argc < 2)
	{
		printf(_USAGE, argv[0]);
		exit(1);
	}

	if (inopts(OPT_NAMES))
	{
		p = 2;
		shownames = 1;
	} else {
		shownames = 0;
	}

	for (a = p; a <= (argc - 1); a++)
	{
		if (ftype(argv[a]) == _DIR)
		{
			printf("%s: %s: Is a directory\n", argv[0], argv[a]);
			continue;
		}

		fptr = fopen(argv[a], "r");
   
		if (!fptr)
		{
			printf("%s: %s: File not found\n", argv[0], argv[a]);
			continue;
		}

		rewind(fptr);
		
		if (shownames)
		{
			printf(NAME_FORMAT, argv[a]);
		}

		while (1)
		{
			c = fgetc(fptr);
			if (feof(fptr))
			{
				break;
			}
			putchar(c);
		}
	
		fclose(fptr);
	}
	
	exit(0);
}
