/* Read Line Numbers Utility
 *
 * Version 1.0
 * 12/23/2020
 *
 * rn.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#define PROG_HELP \
"Read Line Numbers Utility: Display contents of files with line numbers\n\
\n\
rn [-H] <file ...>\n\
\n\
\t[-H] - Display program syntax and options\n\
\n\
\tLine numbers begin at 1 for each specified file.\n"

#define _USAGE "Usage: %s [-H] <file ...>\n"

#define OPT_HELP	'H'

char options[] = "";

enum
{
	_NONE,
	_FILE,
	_DIR
};

int inopts(char opt)
{
	static int sr;
	sr = 0;
	int z;

	for (z = 0; z <= strlen(options); z++)
	{
		if (options[z] == opt)
		{
			sr = 1;
			break;
		} else {
			continue;
		}
	}

	return sr;
}

int ftype(char file[])
{
	struct stat fstat;
	int s = stat(file, &fstat);
	if (s != 0)
	{
		return _NONE;
	}
	if (S_ISREG (fstat.st_mode)) 
	{
		return _FILE;
	} else if (S_ISDIR (fstat.st_mode)) 
	{
		return _DIR;
	} else {
		return _NONE;
	}
}

int nread(char tfile[])
{
	FILE *fptr;
	char buffer[512];
	int line = 0;

	fptr = fopen(tfile,"r");
   
	if (!fptr) {
		return 1;
	}

	rewind(fptr);
   
	while (1) {
		line++;
		fgets(buffer, 512, fptr);
		if (feof(fptr))
		{
			break;
		}
		printf("%d: %s", line, buffer);
	}
	fclose(fptr);
	return 0;
}

int main(int argc, char *argv[])
{
	int a;
	int p = 1;
	int r;

	if (argc >= 2 && argv[1][0] == '-')
	{
		p = 2;

		for (r = 1; r < strlen(argv[1]); r++)
		{
			options[r - 1] = argv[1][r];
		}
	}

	if (inopts(OPT_HELP))
	{
		printf(PROG_HELP);
		exit(0);
	}

	if (argc < 2)
	{
		printf(_USAGE, argv[0]);
		exit(1);
	}

	for (a = p; a <= (argc - 1); a++)
	{
		if (ftype(argv[a]) == _DIR)
		{
			printf("%s: %s: Is a directory\n", argv[0], argv[a]);
			continue;
		} else if (ftype(argv[a]) == _NONE) {
			printf("%s: %s: File not found\n", argv[0], argv[a]);
			continue;
		}
		nread(argv[a]);
	}
	
	exit(0);
}
