/* Write Utility
 *
 * Version 1.0
 * 12/19/2020
 *
 * wt.c
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#define PROG_HELP \
"Write Utility: Write block of text to new files\n\
\n\
wt [-H] <file ...>\n\
\n\
\t[-H] - Display program syntax and options\n\
\n\
\tThis program will not attempt to overwrite an existing file.\n"

#define _USAGE "Usage: %s [-H] <file ...>\n"

#define OPT_HELP	'H'

char options[] = "";

enum
{
	_NONE,
	_FILE,
	_DIR
};

int inopts(char opt)
{
	static int sr;
	sr = 0;
	int z;

	for (z = 0; z <= strlen(options); z++)
	{
		if (options[z] == opt)
		{
			sr = 1;
			break;
		} else {
			continue;
		}
	}

	return sr;
}

int ftype(char file[])
{
	struct stat fstat;
	int s = stat(file, &fstat);
	if (s != 0)
	{
		return _NONE;
	}
	if (S_ISREG (fstat.st_mode)) 
	{
		return _FILE;
	} else if (S_ISDIR (fstat.st_mode)) 
	{
		return _DIR;
	} else {
		return _NONE;
	}
}

int main(int argc, char *argv[])
{
	FILE *fptr;
	char inx[812];
	size_t len;
	int a;
	int p = 1;
	int r;

	if (argc >= 2 && argv[1][0] == '-')
	{
		p = 2;

		for (r = 1; r < strlen(argv[1]); r++)
		{
			options[r - 1] = argv[1][r];
		}
	}

	if (inopts(OPT_HELP))
	{
		printf(PROG_HELP);
		exit(0);
	}

	if (argc < 2)
	{
		printf(_USAGE, argv[0]);
		exit(1);
	}

	for (a = p; a <= (argc - 1); a++)
	{
		if (ftype(argv[a]) == _DIR)
		{
			printf("%s: %s: Is a directory\n", argv[0], argv[a]);
			continue;
		}

		fptr = fopen(argv[a], "r");

		if (fptr)
		{
			printf("%s: %s: File already exists.\n", argv[0], argv[a]);
			fclose(fptr);
			continue;
		}

		fptr = fopen(argv[a], "w");

		if (!fptr)
		{
			printf("%s: Failed to load or create %s.\n", argv[0], argv[a]);
			continue;
		}

		printf("Enter text to write to %s. Use '~' when finished.\n", argv[a]);
	
		while (1)
		{
			fgets(inx, 812, stdin);
			len = strlen(inx);
			if (inx[0] == '~' && len == 2)
			{
				fclose(fptr);
				printf("File %s written.\n", argv[a]);
				if (a == (argc - 1))
				{
					break;
				}
				break;
			} else {
				fprintf(fptr, "%s", inx);
			}
		}
	}
	
	exit(0);
	
}
